// BattleShip01Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BattleShip01.h"
#include "BattleShip01Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBattleShip01Dlg dialog

CBattleShip01Dlg::CBattleShip01Dlg(int numRows, 
                                   int numColumns,
                                   CWnd* pParent /*=NULL*/)
	: CDialog(CBattleShip01Dlg::IDD, pParent),
      m_numColumns(numColumns), 
      m_numRows(numRows), 
      m_xBorder(0), m_yBorder(0),
      m_cellWidth(0), m_cellHeight(0),
      m_ShipNo(0),
      m_ShipSunked(0), m_shotTried(0),
      m_pCell(new TwoDArray(numColumns,numRows))
{
	//{{AFX_DATA_INIT(CBattleShip01Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_hIconCircle = AfxGetApp()->LoadIcon(IDI_ICON_CIRCLE);

    int init_x, init_y, xdir, ydir;
    for (int i=0; i<4; i++)
    {
        newShipPos(5-i, &init_x, &init_y, &xdir, &ydir);
        if (i<1)
            m_pShip[i] = new BigShip(5-i, init_x, init_y, xdir, ydir);
        else
            m_pShip[i] = new Ship(5-i, init_x, init_y, xdir, ydir);
        m_ShipNo++;
    }
}

CBattleShip01Dlg::~CBattleShip01Dlg()
{
    for (int i=0; i<m_ShipNo; i++)
        delete m_pShip[i];
    delete m_pCell;
}

void CBattleShip01Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBattleShip01Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBattleShip01Dlg, CDialog)
	//{{AFX_MSG_MAP(CBattleShip01Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBattleShip01Dlg message handlers

BOOL CBattleShip01Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBattleShip01Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBattleShip01Dlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        int i, j;
        drawGrid(&dc);
        for (i=0; i<m_numRows; i++)
            for (j=0; j<m_numColumns; j++)
                if (m_pCell->elemAt(j, i) == '0')
                    drawSymbol(&dc, m_hIconCircle, j, i);
        for (i=0; i<m_ShipNo; i++)
            m_pShip[i]->draw(&dc, this);

        if (m_ShipSunked >=  m_ShipNo)
        {
            CString strTmp;
            strTmp.Format("Game Over:: you have used %d shots", m_shotTried);
            dc.TextOut(m_xBorder + 2*m_cellWidth, m_yBorder/3,
                       strTmp);
        }

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBattleShip01Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBattleShip01Dlg::drawGrid(CDC *pdc)
{
    int i;

    for (i=0; i<=m_numColumns; i++)
    {
        pdc->MoveTo(m_xBorder+i*m_cellWidth, m_yBorder);
        pdc->LineTo(m_xBorder+i*m_cellWidth,
                    m_yBorder+m_numRows*m_cellHeight);
    }

    for (i=0; i<=m_numRows; i++)
    {
        pdc->MoveTo(m_xBorder, m_yBorder+i*m_cellHeight);
        pdc->LineTo(m_xBorder + m_numColumns * m_cellWidth,
                    m_yBorder+i*m_cellHeight);
    }
}

void CBattleShip01Dlg::drawSymbol(CDC *pdc, HICON hIcon, int col, int row)
{
    int x = m_xBorder + col * m_cellWidth + 1;
    int y = m_yBorder + row * m_cellHeight + 1;
    ::DrawIconEx(pdc->GetSafeHdc(), x, y, hIcon, 
                 m_cellWidth-4, m_cellHeight-4,
                 0, NULL, DI_NORMAL);
}

void CBattleShip01Dlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
    CRect rc;
    GetClientRect(&rc);
    m_xBorder = m_cellWidth = (int)(
        ((double)cx) / ((double)(m_numColumns+2)));
    m_yBorder = m_cellHeight = (int)(
        ((double)cy) / ((double)(m_numRows+2)));
}

void CBattleShip01Dlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
    if (m_ShipSunked < m_ShipNo) 
    {

    CRect rc;
    GetClientRect(&rc);

    int ix, iy;
    if ((point.x > m_xBorder) && 
        (point.x < rc.right-m_xBorder))	
        ix = (point.x-m_xBorder) / m_cellWidth;

    if ((point.y > m_yBorder) && 
        (point.y < rc.bottom-m_yBorder))	
        iy = (point.y-m_yBorder) / m_cellHeight;

    if (m_pCell->elemAt(ix,iy) != '0')
    {
        m_shotTried++;
        m_pCell->elemAt(ix, iy) = '0';
        for (int i=0; i<m_ShipNo; i++)
            if (m_pShip[i]->hit(ix, iy) == 1)
                if (m_pShip[i]->isSunked()) 
                    m_ShipSunked++;
        InvalidateRect(NULL);
    }

    }

	CDialog::OnLButtonUp(nFlags, point);
}

void CBattleShip01Dlg::newShipPos(int length, int *init_x, int *init_y,
                                  int *xdir, int *ydir)
{
    static Random rv;
    int total;
    int i, left, right, up, down;

    if (m_numColumns >= length)
    {
        left = (m_numColumns-length+1)*m_numRows - 1;
        right = left + (m_numColumns-length+1)*m_numRows;
    }
    else
        left = right = 0;

    if (m_numRows >= length)
    {
        up = right + (m_numRows-length+1)*m_numColumns;
        down = up + (m_numRows-length+1)*m_numColumns;
    }
    else
        up = down = right;

    total = down;

    if (total == 0)
    {
        *init_x = *init_y = *xdir = *ydir = 0;
        return;
    }

    do
    {
        i = rv.next(0,total-1);
        if (i<=left) // ship tail points leftward
        {
            *init_x = m_numColumns - 1 - i/m_numRows;
            *init_y = i%m_numRows;
            *xdir = -1;
            *ydir = 0;
        }
        else if (i<=right) // ship tail points rightward
        {
            *init_x = (i-left-1)/m_numRows;
            *init_y = i%m_numRows;
            *xdir = 1;
            *ydir = 0;
        }
        else if (i<=up) // ship tail points upward
        {
            *init_x = (i-right-1)%m_numColumns;
            *init_y = m_numRows - 1 - (i-right-1)/m_numColumns;
            *xdir = 0;
            *ydir = -1;
        }
        else // ship tail points downward
        {
            *init_x = (i-up-1)%m_numColumns;
            *init_y = (i-up-1)/m_numColumns;
            *xdir = 0;
            *ydir = 1;
        }
    } while (shipOverlapped(length, *init_x, *init_y, *xdir, *ydir));
}

int CBattleShip01Dlg::shipOverlapped(int length, int init_x, int init_y,
                                     int xdir, int ydir)
{
    Ship tmpShip(length, init_x, init_y, xdir, ydir);
    for (int i=0; i<m_ShipNo; i++)
        if (m_pShip[i]->getTouched(tmpShip)) return 1;
    return 0;
}
